function [ new_pos, new_vel ] = COMPUTE_NEW_POS( pos, vel, xmin, xmax )

% Computes new position for the particles and updates velocity
new_pos = pos + vel;
new_vel = vel;

tmp_pos_1 = round( new_pos );
tmp_pos_2 = round( pos );
if isequal(tmp_pos_1,tmp_pos_2) 
    tmp_pos_3 = tmp_pos_1;
    iter = 1;
    while isequal(tmp_pos_3,tmp_pos_2) && iter <= length( tmp_pos_2 )
        p = randi( length( tmp_pos_3 ) );
        tmp_pos_3( 1, p ) = tmp_pos_1( 1, p ) - 1;
        for i = 1 : length( tmp_pos_3 )
            if tmp_pos_3( 1, i ) < xmin( i )
                tmp_pos_3( 1, i ) = xmin( i );
            elseif tmp_pos_3( 1, i ) > xmax( i )
                tmp_pos_3( 1, i ) = xmax( i );
            end
        end
        tmp_pos_3 = round( tmp_pos_3 );
        iter = iter + 1;
    end
    new_pos( 1, p ) = tmp_pos_3( 1, p );
end

end

% for i = 1 : length( new_pos )
%     tmp_round = round( new_pos(i) );
%     tmp_diff = new_pos(i) - tmp_round;
%     if tmp_diff > 0
%         if rand() < betacdf( tmp_diff/0.5, 3, 1 )
%             new_pos(i) = tmp_round + 0.5;
%         end
%     else
%         if rand() < betacdf( -tmp_diff/0.5, 3, 1 )
%             new_pos(i) = tmp_round - 0.5;
%         end
%     end
% end
%     tmp_pos_3 = tmp_pos_1;
%     % check_sum = 1;
%     while isequal(tmp_pos_3,tmp_pos_2) % || check_sum ~= 0
%         p = randperm( length( tmp_pos_3 ), 2 );
%         if rand() < 0.5
%             tmp_pos_3( 1, p(1) ) = tmp_pos_1( 1, p(1) ) + 1;
%             tmp_pos_3( 1, p(2) ) = tmp_pos_1( 1, p(2) ) - 1;
%         else
%             tmp_pos_3( 1, p(1) ) = tmp_pos_1( 1, p(1) ) - 1;
%             tmp_pos_3( 1, p(2) ) = tmp_pos_1( 1, p(2) ) + 1;
%         end
%         for i = 1 : length( tmp_pos_3 )
%             if tmp_pos_3( 1, i ) < xmin( i )
%                 tmp_pos_3( 1, i ) = xmin( i );
%             elseif tmp_pos_3( 1, i ) > xmax( i )
%                 tmp_pos_3( 1, i ) = xmax( i );
%             end
%         end
%         tmp_pos_3 = round( tmp_pos_3 );
%        %  check_sum = abs( sum( tmp_pos_3 ) - sum( tmp_pos_2 ) );
%     end
%     new_pos( 1, p(1) ) = tmp_pos_3( 1, p(1) );
%     new_pos( 1, p(2) ) = tmp_pos_3( 1, p(2) );
% new_pos( 1, p(1) ) = round( new_pos( 1, p(1) ) ) + 1;
% new_pos( 1, p(2) ) = round( new_pos( 1, p(2) ) ) - 1;