function [ new_pos, new_vel ] = COMPUTE_NEW_POS_TEP( pos, vel, xmin, xmax )

% Computes new position for the particles and updates velocity
new_vel = vel;

tmp_pos_1 = round( pos );
tmp_pos_2 = round( pos );
iter = 1;
while isequal(tmp_pos_1,tmp_pos_2) && iter <= length( tmp_pos_2 )
    p = randi( length( tmp_pos_2 ) );
    tmp_pos_2( 1, p ) = tmp_pos_1( 1, p ) - 1;
    for i = 1 : length( tmp_pos_2 )
        if tmp_pos_2( 1, i ) < xmin( i )
            tmp_pos_2( 1, i ) = xmin( i );
        elseif tmp_pos_2( 1, i ) > xmax( i )
            tmp_pos_2( 1, i ) = xmax( i );
        end
    end
    tmp_pos_2 = round( tmp_pos_2 );
    iter = iter + 1;
end

new_pos = tmp_pos_2;

end